'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defaults = require('./defaults');

var defaultOptions = _interopRequireWildcard(_defaults);

var _helpers = require('./helpers');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

exports.default = function (client) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var _defaultOptions$optio = _extends({}, defaultOptions, options);

  var onSuccess = _defaultOptions$optio.onSuccess;
  var onError = _defaultOptions$optio.onError;
  var onComplete = _defaultOptions$optio.onComplete;


  return function (_ref) {
    var getState = _ref.getState;
    var dispatch = _ref.dispatch;
    return function (next) {
      return function (action) {

        if (!action.payload || !action.payload.request) {
          return next(action);
        }

        var _getActionTypes = (0, _helpers.getActionTypes)(action);

        var _getActionTypes2 = _slicedToArray(_getActionTypes, 1);

        var REQUEST = _getActionTypes2[0];

        next(_extends({}, action, { type: REQUEST }));

        return client.request(action.payload.request).then(function (response) {
          var newAction = onSuccess({ action: action, next: next, response: response, getState: getState, dispatch: dispatch });
          onComplete({ action: newAction, next: next, getState: getState, dispatch: dispatch });
        }, function (error) {
          var newAction = onError({ action: action, next: next, error: error, getState: getState, dispatch: dispatch });
          onComplete({ action: newAction, next: next, getState: getState, dispatch: dispatch });
        });
      };
    };
  };
};